Index: LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_main.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_main.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_main.F90	(revision 4446)
@@ -1,3 +1,2 @@
-
 ! $Id$
 !
@@ -19,8 +18,9 @@
       USE thermcell_ini_mod, ONLY: thermcell_ini,dqimpl,dvdq,prt_level,lunout,prt_level
       USE thermcell_ini_mod, ONLY: iflag_thermals_closure,iflag_thermals_ed,tau_thermals,r_aspect_thermals
+      USE thermcell_ini_mod, ONLY: iflag_thermals_down, fact_thermals_down
       USE thermcell_ini_mod, ONLY: RD,RG
 
 #ifdef ISO
-  USE infotrac_phy, ONLY : ntraciso
+  USE infotrac_phy, ONLY : ntiso
 #ifdef ISOVERIF
   USE isotopes_mod, ONLY : iso_eau,iso_HDO
@@ -61,4 +61,20 @@
 !    15 and 17 correspond to the activation of the stratocumulus "bidouille"
 !
+! Using
+!    abort_physic 
+!    iso_verif_aberrant_encadre
+!    iso_verif_egalite
+!    test_ltherm
+!    thermcell_closure
+!    thermcell_dq
+!    thermcell_dry
+!    thermcell_dv2
+!    thermcell_env
+!    thermcell_flux2
+!    thermcell_height
+!    thermcell_plume
+!    thermcell_plume_5B
+!    thermcell_plume_6A
+!
 !=======================================================================
 
@@ -75,10 +91,12 @@
       real, intent(in), dimension(ngrid,nlay)    :: pt,pu,pv,po,pplay,pphi,zpspsk
       real, intent(in), dimension(ngrid,nlay+1)  :: pplev
+      integer, intent(out), dimension(ngrid) :: lmax
       real, intent(out), dimension(ngrid,nlay)   :: pdtadj,pduadj,pdvadj,pdoadj,entr0,detr0
       real, intent(out), dimension(ngrid,nlay)   :: ztla,zqla,zqta,zqsatth,zthl
       real, intent(out), dimension(ngrid,nlay+1) :: fm0,zw2,fraca
-      real, intent(out), dimension(ngrid) :: zmax0,f0
+      real, intent(inout), dimension(ngrid) :: zmax0,f0
       real, intent(out), dimension(ngrid,nlay) :: ztva,ztv
       logical, intent(in) :: debut
+      real,intent(out), dimension(ngrid,nlay) :: ratqscth,ratqsdiff
 
       real, intent(out), dimension(ngrid) :: pcon
@@ -105,9 +123,9 @@
       logical sorties
       real, dimension(ngrid) :: linter,zmix, zmax_sec
-      integer,dimension(ngrid) :: lmax,lmin,lmix,lmix_bis,nivcon
+      integer,dimension(ngrid) :: lmin,lmix,lmix_bis,nivcon
       real, dimension(ngrid,nlay) :: ztva_est
       real, dimension(ngrid,nlay) :: deltaz,zlay,zh,zdthladj,zu,zv,zo,zl,zva,zua,zoa
       real, dimension(ngrid,nlay) :: zta,zha,q2,wq,wthl,wthv,thetath2,wth2
-      real, dimension(ngrid,nlay) :: ratqscth,ratqsdiff,rho,masse
+      real, dimension(ngrid,nlay) :: rho,masse
       real, dimension(ngrid,nlay+1) :: zw_est,zlev
       real, dimension(ngrid) :: wmax,wmax_tmp
@@ -116,4 +134,5 @@
       real, dimension(ngrid,nlay) :: zqsat,csc
       real, dimension(ngrid) :: zcon,zcon2,alim_star_tot,f
+      real, dimension(ngrid,nlay) :: entrdn,detrdn
 
       character (len=20) :: modname='thermcell_main'
@@ -122,6 +141,6 @@
 
 #ifdef ISO
-      REAL xtpo(ntraciso,ngrid,nlay),xtpdoadj(ntraciso,ngrid,nlay)
-      REAL xtzo(ntraciso,ngrid,nlay)
+      REAL xtpo(ntiso,ngrid,nlay),xtpdoadj(ntiso,ngrid,nlay)
+      REAL xtzo(ntiso,ngrid,nlay)
       REAL xtpdoadj_tmp(ngrid,nlay)
       REAL xtpo_tmp(ngrid,nlay)
@@ -137,5 +156,4 @@
 !   ---------------
 !
-
    fm=0. ; entr=0. ; detr=0.
 
@@ -360,5 +378,5 @@
      &           zlev,lmax,zmax,zmax0,zmix,wmax)
 ! Attention, w2 est transforme en sa racine carree dans cette routine
-! Le probleme vient du fait que linter et lmix sont souvent égaux à 1.
+! Le probleme vient du fait que linter et lmix sont souvent egaux a 1.
       wmax_tmp=0.
       do  l=1,nlay
@@ -447,4 +465,5 @@
      &       entr_star,detr_star,f,rhobarz,zlev,zw2,fm,entr,  &
      &       detr,zqla,lev_out,lunout1,igout)
+
 !IM 060508    &       detr,zqla,zmax,lev_out,lunout,igout)
 
@@ -470,16 +489,44 @@
       endif
 
+!------------------------------------------------------------------
+! Calcul de la fraction de l'ascendance
+!------------------------------------------------------------------
+      do ig=1,ngrid
+         fraca(ig,1)=0.
+         fraca(ig,nlay+1)=0.
+      enddo
+      do l=2,nlay
+         do ig=1,ngrid
+            if (zw2(ig,l).gt.1.e-10) then
+            fraca(ig,l)=fm(ig,l)/(rhobarz(ig,l)*zw2(ig,l))
+            else
+            fraca(ig,l)=0.
+            endif
+         enddo
+      enddo
+     
 !c------------------------------------------------------------------
 !   calcul du transport vertical
 !------------------------------------------------------------------
-
-      call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
-     &                    zthl,zdthladj,zta,lev_out)
-      call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
-     &                   po,pdoadj,zoa,lev_out)
+      IF (iflag_thermals_down .GT. 0) THEN
+        if (debut) print*,'WARNING !!! routine thermcell_down en cours de developpement'
+        entrdn=fact_thermals_down*detr0
+        detrdn=fact_thermals_down*entr0 
+        ! we want to transport potential temperature, total water and momentum
+        CALL thermcell_updown_dq(ngrid,nlay,ptimestep,lmax,entr0,detr0,entrdn,detrdn,masse,zthl,zdthladj)
+        CALL thermcell_updown_dq(ngrid,nlay,ptimestep,lmax,entr0,detr0,entrdn,detrdn,masse,po,pdoadj)
+        CALL thermcell_updown_dq(ngrid,nlay,ptimestep,lmax,entr0,detr0,entrdn,detrdn,masse,zu,pduadj)
+        CALL thermcell_updown_dq(ngrid,nlay,ptimestep,lmax,entr0,detr0,entrdn,detrdn,masse,zv,pdvadj)
+      ELSE
+      !--------------------------------------------------------------
+
+        call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
+        &                    zthl,zdthladj,zta,lev_out)
+        call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
+        &                   po,pdoadj,zoa,lev_out)
 
 #ifdef ISO
-        ! C Risi: on utilise directement la même routine
-        do ixt=1,ntraciso
+        ! C Risi: on utilise directement la meme routine
+        do ixt=1,ntiso
           do ll=1,nlay
             DO ig=1,ngrid
@@ -495,5 +542,5 @@
             enddo
           enddo
-        enddo !do ixt=1,ntraciso
+        enddo
 #endif
 
@@ -519,22 +566,4 @@
 
 
-
-!------------------------------------------------------------------
-! Calcul de la fraction de l'ascendance
-!------------------------------------------------------------------
-      do ig=1,ngrid
-         fraca(ig,1)=0.
-         fraca(ig,nlay+1)=0.
-      enddo
-      do l=2,nlay
-         do ig=1,ngrid
-            if (zw2(ig,l).gt.1.e-10) then
-            fraca(ig,l)=fm(ig,l)/(rhobarz(ig,l)*zw2(ig,l))
-            else
-            fraca(ig,l)=0.
-            endif
-         enddo
-      enddo
-     
 !------------------------------------------------------------------
 !  calcul du transport vertical du moment horizontal
@@ -561,4 +590,5 @@
 
       endif
+    ENDIF
 
 !     print*,'13 OK convect8'
@@ -716,4 +746,5 @@
       real seuil
       character*21 comment
+
       seuil=0.25
 
@@ -741,5 +772,5 @@
 ! nrlmd le 10/04/2012   Transport de la TKE par le thermique moyen pour la fermeture en ALP 
 !                       On transporte pbl_tke pour donner therm_tke
-!                       Copie conforme de la subroutine DTKE dans physiq.F écrite par Frederic Hourdin
+!                       Copie conforme de la subroutine DTKE dans physiq.F ecrite par Frederic Hourdin
 
 !=======================================================================
Index: LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_plume.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_plume.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_plume.F90	(revision 4446)
@@ -63,23 +63,24 @@
 
 
-      REAL wa_moy(ngrid,nlay+1)
-      REAL entr(ngrid,nlay),detr(ngrid,nlay)
-      REAL ztv_est(ngrid,nlay)
-      REAL zqla_est(ngrid,nlay)
-      REAL zta_est(ngrid,nlay)
-      REAL ztemp(ngrid),zqsat(ngrid)
+      REAL,dimension(ngrid,nlay+1) :: wa_moy
+      REAL,dimension(ngrid,nlay) :: entr,detr
+      REAL,dimension(ngrid,nlay) :: ztv_est
+      REAL,dimension(ngrid,nlay) :: zqla_est
+      REAL,dimension(ngrid,nlay) :: zta_est
+      REAL,dimension(ngrid) :: ztemp,zqsat
       REAL zdw2,zdw2bis
       REAL zw2modif
       REAL zw2fact,zw2factbis
-      REAL zeps(ngrid,nlay)
-
-      REAL    wmaxa(ngrid)
+      REAL,dimension(ngrid,nlay) :: zeps
+
+      REAL,dimension(ngrid) :: wmaxa
 
       INTEGER ig,l,k,lt,it,lm,nbpb
 
-      real zdz,zbuoy(ngrid,nlay),zalpha,gamma(ngrid,nlay),zdqt(ngrid,nlay),zw2m
-      real zbuoyjam(ngrid,nlay),zdqtjam(ngrid,nlay)
+      real,dimension(ngrid,nlay) :: zbuoy,gamma,zdqt
+      real zdz,zalpha,zw2m
+      real,dimension(ngrid,nlay) :: zbuoyjam,zdqtjam
       real zdz2,zdz3,lmel,entrbis,zdzbis
-      real d_temp(ngrid)
+      real,dimension(ngrid) :: d_temp
       real ztv1,ztv2,factinv,zinv,zlmel
       real zlmelup,zlmeldwn,zlt,zltdwn,zltup
@@ -90,9 +91,9 @@
       real eps
       logical Zsat
-      LOGICAL active(ngrid),activetmp(ngrid)
+      LOGICAL,dimension(ngrid) :: active,activetmp
       REAL fact_gamma,fact_gamma2,fact_epsilon2
 
 
-      REAL c2(ngrid,nlay)
+      REAL,dimension(ngrid,nlay) :: c2
 
       if (ngrid==1) print*,'THERMCELL PLUME MODIFIE 2014/07/11'
@@ -443,4 +444,4 @@
 
 
-     return 
+ RETURN
      end
Index: LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_plume_6A.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_plume_6A.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/thermcell_plume_6A.F90	(revision 4446)
@@ -55,7 +55,7 @@
       REAL zw2modif
       REAL zw2fact,zw2factbis
-      REAL zeps(ngrid,nlay)
-
-      REAL    wmaxa(ngrid)
+      REAL,dimension(ngrid,nlay) :: zeps
+
+      REAL, dimension(ngrid) ::    wmaxa(ngrid)
 
       INTEGER ig,l,k,lt,it,lm
@@ -70,8 +70,9 @@
       real,dimension(ngrid,nlay) :: zta_est
 
-      real zdz,zbuoy(ngrid,nlay),zalpha,gamma(ngrid,nlay),zdqt(ngrid,nlay),zw2m
-      real zbuoyjam(ngrid,nlay),zdqtjam(ngrid,nlay)
+      real,dimension(ngrid,nlay) :: zbuoy,gamma,zdqt
+      real zdz,zalpha,zw2m
+      real,dimension(ngrid,nlay) :: zbuoyjam,zdqtjam
       real zbuoybis,zdz2,zdz3,lmel,entrbis,zdzbis
-      real d_temp(ngrid)
+      real, dimension(ngrid) :: d_temp
       real ztv1,ztv2,factinv,zinv,zlmel
       real zlmelup,zlmeldwn,zlt,zltdwn,zltup
@@ -82,8 +83,8 @@
       real eps
       logical Zsat
-      LOGICAL active(ngrid),activetmp(ngrid)
+      LOGICAL,dimension(ngrid) :: active,activetmp
       REAL fact_gamma,fact_gamma2,fact_epsilon2
       REAL coefc
-      REAL c2(ngrid,nlay)
+      REAL,dimension(ngrid,nlay) :: c2
 
       if (ngrid==1) print*,'THERMCELL PLUME MODIFIE 2014/07/11'
@@ -137,4 +138,11 @@
       lmix_bis(:)=2
       wmaxa(:)=0.
+
+! Initialisation a 0  en cas de sortie dans replay
+      zqsat(:)=0.
+      zta_est(:,:)=0.
+      zdqt(:,:)=0.
+      zdqtjam(:,:)=0.
+      c2(:,:)=0.
 
 
Index: LMDZ6/branches/Portage_acc/libf/phylmd/tracco2i_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/tracco2i_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/tracco2i_mod.F90	(revision 4446)
@@ -103,5 +103,5 @@
     IF (debutphy) THEN
 
-! Initialisation de tr_seri(id_CO2) si pas initialise
+! Initialization of tr_seri(id_CO2) If it is not initialized
       IF (MAXVAL(tr_seri(:,:,id_CO2)).LT.1.e-15) THEN 
         tr_seri(:,:,id_CO2)=co2_ppm0*1.e-6/RMD*RMCO2 !--initialised from co2_ppm0 in rdem
@@ -226,5 +226,7 @@
 
       DO i=1, klon  
-          fco2_ocean_cor(i)=(var_fco2_ocean_cor*(RMCO2/RMC)*(pctsrf(i,is_oce)+pctsrf(i,is_sic))/ocean_area_tot/(secinday*year_len))*1.e12
+         fco2_ocean_cor(i)=(var_fco2_ocean_cor*(RMCO2/RMC) &
+              *(pctsrf(i,is_oce)+pctsrf(i,is_sic))/ocean_area_tot &
+              /(secinday*year_len))*1.e12
       ENDDO
 
@@ -305,7 +307,11 @@
 
 !--compute a global mean CO2 value and print its value in ppm
-       IF (is_mpi_root) THEN
+       IF (is_mpi_root .AND. is_omp_root) THEN
          RCO2_tot=SUM(co2_glo*m_air_glo)  !--unit kg CO2
          RCO2_glo=RCO2_tot/SUM(m_air_glo) !--unit kg CO2 / kg air
+         ! the following operation is only to maintain precision consistency
+         ! of RCO2_glo which differs whether it is directly computed or read from
+         ! a restart file (after having been computed)
+         RCO2_glo = FLOAT(INT(RCO2_glo * 1e8))/1e8
          PRINT *,'tracco2i: global CO2 in ppm =', RCO2_glo*1.e6*RMD/RMCO2
          PRINT *,'tracco2i: total CO2 in kg =', RCO2_tot
@@ -314,4 +320,5 @@
        CALL bcast(RCO2_glo)
        day_pre=day_cur
+
 !--if not carbon_cycle_tr, then we reinitialize the CO2 each day to its global mean value
        IF (.NOT.carbon_cycle_tr) THEN 
Index: LMDZ6/branches/Portage_acc/libf/phylmd/tracinca_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/tracinca_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/tracinca_mod.F90	(revision 4446)
@@ -12,4 +12,5 @@
                      ! config_inca='chem' => INCA with chemistry
                      ! config_inca='aero' => INCA with aerosols
+                     ! config_inca='aeNP' => INCA with aerosols NP (?)
 CONTAINS
 
@@ -17,6 +18,5 @@
     ! This subroutine initialize some control varaibles. 
 
-    USE infotrac_phy, ONLY: nbtr
-    USE ioipsl_getin_p_mod, ONLY: getin_p
+    USE infotrac_phy, ONLY: nbtr, type_trac
     IMPLICIT NONE
     
@@ -25,8 +25,15 @@
     LOGICAL,INTENT(OUT) :: lessivage
     
-    
     ! Initialization
     lessivage  =.FALSE.
     aerosol(:) = .FALSE.
+
+    !--- COHERENCE TEST BETWEEN "type_trac" AND "config_inca"
+    IF(ANY(type_trac == ['inca','inco']) .AND. ALL(config_inca /= ['aero','aeNP','chem'])) CALL abort_gcm('tracinca_init', &
+       'INCA enabled, but unknown config_inca = "'//TRIM(config_inca)//'". Please modify "run.def"', 1)
+
+    !--- PROBLEM IF "config_inca" DIFFERS FROM "none" AND INCA HAS NOT BEEN ACTIVATED
+    IF(ALL(type_trac /= ['inca','inco'])  .AND.    config_inca /= 'none')                  CALL abort_gcm('tracinca_init', &
+       'INCA disabled, but config_inca = "'//TRIM(config_inca)//'" should be "none". Please modify "run.def"', 1)
 
   END SUBROUTINE tracinca_init
@@ -82,5 +89,5 @@
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: pphi    ! geopotentiel
     REAL,DIMENSION(klon),INTENT(IN)        :: pphis
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau liquide nuageuse
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau condensee pour le radiatif
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldfra  ! fraction nuageuse (tous les nuages)
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
Index: LMDZ6/branches/Portage_acc/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/traclmdz_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/traclmdz_mod.F90	(revision 4446)
@@ -96,5 +96,4 @@
     USE indice_sol_mod
     USE print_control_mod, ONLY: lunout
-    USE strings_mod, ONLY: strLower
 
 ! Input variables
@@ -175,24 +174,24 @@
     it = 0
     DO iq = 1, nqtot
-       IF(.NOT.(tracers(iq)%isAdvected .AND. tracers(iq)%isInPhysics)) CYCLE
+       IF(.NOT.(tracers(iq)%isInPhysics)) CYCLE
        it = it+1
-       SELECT CASE(strLower(tracers(iq)%name))
-         CASE("rn");      id_rn     = it ! radon
-         CASE("pb");      id_pb     = it ! plomb
-         CASE("aga");     id_aga    = it ! Age of stratospheric air
-         CASE("be","be7");id_be     = it ! Recherche du Beryllium 7
-         CASE("o3");      id_o3     = it ! Recherche de l'ozone
-         CASE("pcsat");   id_pcsat  = it
-         CASE("pcocsat"); id_pcocsat= it
-         CASE("pcq");     id_pcq    = it
-         CASE("pcs0");    id_pcs0   = it
-         CASE("pcos0");   id_pcos0  = it
-         CASE("pcq0");    id_pcq0   = it
+       SELECT CASE(tracers(iq)%name)
+         CASE("RN");                  id_rn     = it ! radon
+         CASE("PB");                  id_pb     = it ! plomb
+         CASE("Aga","AGA");           id_aga    = it ! Age of stratospheric air
+         CASE("Be","BE","Be7","BE7"); id_be     = it ! Recherche du Beryllium 7
+         CASE("o3","O3");             id_o3     = it ! Recherche de l'ozone
+         CASE("pcsat",  "Pcsat");     id_pcsat  = it
+         CASE("pcocsat","Pcocsat");   id_pcocsat= it
+         CASE("pcq",    "Pcq");       id_pcq    = it
+         CASE("pcs0",   "Pcs0");      id_pcs0   = it
+         CASE("pcos0",  "Pcos0");     id_pcos0  = it
+         CASE("pcq0",   "Pcq0");      id_pcq0   = it
          CASE DEFAULT
            WRITE(lunout,*) 'This is an unknown tracer in LMDZ : ', trim(tracers(iq)%name)
        END SELECT
 
-       SELECT CASE(strLower(tracers(iq)%name))
-         CASE("pb")                        !--- RomP >>> profil initial de PB210 
+       SELECT CASE(tracers(iq)%name)
+         CASE("PB")                        !--- RomP >>> profil initial de PB210 
            OPEN(ilesfil2,file='prof.pb210',status='old',iostat=irr2)
            IF(irr2 == 0) THEN 
@@ -203,7 +202,7 @@
              tr_seri(:,:,id_pb) = plomb(:,:)
            ELSE
-             WRITE(lunout,*)'Prof. Pb210 does not exist: use restart values'
+             WRITE(lunout,*)'prof.pb210 does not exist: use restart values'
            END IF
-         CASE("aga")
+         CASE("Aga","AGA")
            radio(id_aga) = .FALSE.
            aerosol(id_aga) = .FALSE.
@@ -217,5 +216,5 @@
               lev_1p5km=klev/2
            END IF
-         CASE("be","be7")
+         CASE("Be","BE","Be7","BE7")
            ALLOCATE( srcbe(klon,klev) )
            radio(id_be) = .TRUE.
@@ -234,8 +233,8 @@
              WRITE(lunout,*)'Prof. Be7 does not exist: use restart values'
            END IF
-         CASE("o3")                         !--- Parametrisation par la chimie de Cariolle
+         CASE("o3","O3")                    !--- Parametrisation par la chimie de Cariolle
            CALL alloc_coefoz                !--- Allocate ozone coefficients
            CALL press_coefoz                !--- Read input pressure levels
-         CASE("pcs0","pcos0","pcq0")
+         CASE("pcs0","Pcs0", "pcos0","Pcos0", "pcq0","Pcq0")
            conv_flg(it)=0                   !--- No transport by convection for this tracer
        END SELECT
Index: LMDZ6/branches/Portage_acc/libf/phylmd/transp.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/transp.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/transp.F90	(revision 4446)
@@ -2,6 +2,6 @@
 ! $Id$
 
-SUBROUTINE transp(paprs, tsol, t, q, ql, qs, u, v, geom, vtran_e, vtran_q, utran_e, &
-    utran_q, vtran_w, utran_w)
+SUBROUTINE transp(paprs, tsol, t, q, ql, qs, u, v, geom, & 
+                  utran_e, vtran_e, utran_q, vtran_q, utran_w, vtran_w)
 
   USE dimphy
@@ -15,37 +15,43 @@
   include "YOMCST.h"
 
-  REAL paprs(klon, klev+1), tsol(klon)
-  REAL t(klon, klev), q(klon, klev), ql(klon, klev), qs(klon, klev)
-  REAL u(klon, klev), v(klon, klev)
-  REAL utran_e(klon), utran_q(klon), vtran_e(klon), vtran_q(klon)
-  REAL utran_w(klon), vtran_w(klon)
+  !--inputs
+  REAL, INTENT(IN)  :: paprs(klon, klev+1), tsol(klon), geom(klon, klev)
+  REAL, INTENT(IN)  :: t(klon, klev), q(klon, klev), ql(klon, klev), qs(klon, klev)
+  REAL, INTENT(IN)  :: u(klon, klev), v(klon, klev)
+  !--outputs
+  REAL, INTENT(OUT) :: utran_e(klon), vtran_e(klon) !--lateral flux of dry static energy (J m-1 s-1)
+  REAL, INTENT(OUT) :: utran_q(klon), vtran_q(klon) !--lateral flux of water vapour (kg m-1 s-1)
+  REAL, INTENT(OUT) :: utran_w(klon), vtran_w(klon) !--lateral flux of total water (kg m-1 s-1)
+  !--local variables
+  INTEGER i, l
+  REAL e, dm
+  ! ------------------------------------------------------------------
 
-  INTEGER i, l
-  ! ------------------------------------------------------------------
-  REAL geom(klon, klev), e
-  ! ------------------------------------------------------------------
-  DO i = 1, klon
-    utran_e(i) = 0.0
-    utran_q(i) = 0.0
-    vtran_e(i) = 0.0
-    vtran_q(i) = 0.0
-    utran_w(i) = 0.0
-    vtran_w(i) = 0.0
-  END DO
+  !--initialisations
+  utran_e(:) = 0.0
+  utran_q(:) = 0.0
+  vtran_e(:) = 0.0
+  vtran_q(:) = 0.0
+  utran_w(:) = 0.0
+  vtran_w(:) = 0.0
 
+  !--vertical integration of diagnostics
   DO l = 1, klev
     DO i = 1, klon
+      dm= (paprs(i,l)-paprs(i,l+1))/RG  !--mass of layer kg m-2
+      !--moist static energy
 !      e = rcpd*t(i, l) + rlvtt*q(i, l) + geom(i, l)
+      !--dry static energy
       e = rcpd*t(i, l) + geom(i, l)
-      utran_e(i) = utran_e(i) + u(i, l)*e*(paprs(i,l)-paprs(i,l+1))/rg
-      utran_q(i) = utran_q(i) + u(i, l)*q(i, l)*(paprs(i,l)-paprs(i,l+1))/rg
-      utran_w(i) = utran_w(i) + u(i, l)*(q(i, l)+ql(i, l)+qs(i, l))           &
-                                       *(paprs(i,l)-paprs(i,l+1))/rg
-      vtran_e(i) = vtran_e(i) + v(i, l)*e*(paprs(i,l)-paprs(i,l+1))/rg
-      vtran_q(i) = vtran_q(i) + v(i, l)*q(i, l)*(paprs(i,l)-paprs(i,l+1))/rg
-      vtran_w(i) = vtran_w(i) + v(i, l)*(q(i, l)+ql(i, l)+qs(i, l))           &
-                                       *(paprs(i,l)-paprs(i,l+1))/rg
-    END DO
-  END DO
+      utran_e(i) = utran_e(i) + u(i, l)*e*dm
+      vtran_e(i) = vtran_e(i) + v(i, l)*e*dm
+      !--water vapour
+      utran_q(i) = utran_q(i) + u(i, l)*q(i,l)*dm 
+      vtran_q(i) = vtran_q(i) + v(i, l)*q(i,l)*dm
+      !--total water
+      utran_w(i) = utran_w(i) + u(i, l)*(q(i,l)+ql(i,l)+qs(i,l))*dm 
+      vtran_w(i) = vtran_w(i) + v(i, l)*(q(i,l)+ql(i,l)+qs(i,l))*dm
+    ENDDO
+  ENDDO
 
   RETURN
